Index: cards/FCC/FCChh.tcl
===================================================================
--- cards/FCC/FCChh.tcl	(revision fce5dd5917b4faa3bffdb1bef9a0d5d332bbaf13)
+++ cards/FCC/FCChh.tcl	(revision 0c5bf12d3fec09f844a78e51652a97271f394db8)
@@ -51,7 +51,19 @@
   GenMissingET
 
-  GenJetFinder
-  FastJetFinder
-  FatJetFinder
+  GenJetFinder02
+  GenJetFinder04
+  GenJetFinder08
+
+  FastJetFinder02
+  FastJetFinder04
+  FastJetFinder08
+
+  CaloJetFinder02
+  CaloJetFinder04
+  CaloJetFinder08
+
+  TrackJetFinder02
+  TrackJetFinder04
+  TrackJetFinder08
 
   JetEnergyScale
@@ -251,5 +263,5 @@
   set TrackOutputArray tracks
 
-  set EtaPhiRes 0.001
+  set EtaPhiRes 0.01
   set EtaMax 6.0
 
@@ -476,4 +488,5 @@
   add InputArray ECal/ecalTowers
   add InputArray HCal/hcalTowers
+  add InputArray MuonMomentumSmearing/muons
   set OutputArray towers
 }
@@ -549,4 +562,16 @@
 
 
+#########################
+# Gen Missing ET merger
+########################
+
+module Merger GenMissingET {
+
+# add InputArray InputArray
+  add InputArray NeutrinoFilter/filteredParticles
+  set MomentumOutputArray momentum
+}
+
+
 #####################
 # MC truth jet finder
@@ -555,7 +580,34 @@
 # TBC: is jet radius fine?
 
-module FastJetFinder GenJetFinder {
-#  set InputArray NeutrinoFilter/filteredParticles
-  set InputArray Delphes/stableParticles
+module FastJetFinder GenJetFinder02 {
+  set InputArray NeutrinoFilter/filteredParticles
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.2
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.2
+
+  set JetPTMin 25.0
+}
+
+
+#####################
+# MC truth jet finder
+#####################
+
+# TBC: is jet radius fine?
+
+module FastJetFinder GenJetFinder04 {
+  set InputArray NeutrinoFilter/filteredParticles
 
   set OutputArray jets
@@ -565,51 +617,7 @@
   set ParameterR 0.4
 
-  set JetPTMin 5.0
-}
-
-#########################
-# Gen Missing ET merger
-########################
-
-module Merger GenMissingET {
-
-# add InputArray InputArray
-  add InputArray NeutrinoFilter/filteredParticles
-  set MomentumOutputArray momentum
-}
-
-
-
-############
-# Jet finder
-############
-
-# TBC need to include jet substructure variables
-# TBC is jet radius fine?
-
-module FastJetFinder FastJetFinder {
-#  set InputArray Calorimeter/towers
-  set InputArray EFlowMerger/eflow
-
-  set OutputArray jets
-
-  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
-  # 7: anti-kt with winner-take-all axis (for N-subjettiness), 8 N-jettiness
-
-  set JetAlgorithm 6
-  set ParameterR 0.4
-
   set ComputeNsubjettiness 1
   set Beta 1.0
   set AxisMode 4
-
-  set ComputeTrimming 1
-  set RTrim 0.2
-  set PtFracTrim 0.05
-
-  set ComputePruning 1
-  set ZcutPrun 0.1
-  set RcutPrun 0.5
-  set RPrun 0.4
 
   set ComputeSoftDrop 1
@@ -618,13 +626,14 @@
   set R0SoftDrop 0.4
 
-  set JetPTMin 30.0
-}
-
-##################
-# Fat Jet finder
-##################
-
-module FastJetFinder FatJetFinder {
-  set InputArray EFlowMerger/eflow
+  set JetPTMin 25.0
+}
+#####################
+# MC truth jet finder
+#####################
+
+# TBC: is jet radius fine?
+
+module FastJetFinder GenJetFinder08 {
+  set InputArray NeutrinoFilter/filteredParticles
 
   set OutputArray jets
@@ -637,13 +646,4 @@
   set Beta 1.0
   set AxisMode 4
-
-  set ComputeTrimming 1
-  set RTrim 0.2
-  set PtFracTrim 0.05
-
-  set ComputePruning 1
-  set ZcutPrun 0.1
-  set RcutPrun 0.5
-  set RPrun 0.8
 
   set ComputeSoftDrop 1
@@ -652,5 +652,237 @@
   set R0SoftDrop 0.8
 
-  set JetPTMin 200.0
+  set JetPTMin 25.0
+}
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder FastJetFinder02 {
+  set InputArray EFlowMerger/eflow
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.2
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.2
+
+  set JetPTMin 25.0
+}
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder FastJetFinder04 {
+  set InputArray EFlowMerger/eflow
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.4
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.4
+
+  set JetPTMin 25.0
+}
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder FastJetFinder08 {
+  set InputArray EFlowMerger/eflow
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.8
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.8
+
+  set JetPTMin 25.0
+}
+
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder CaloJetFinder02 {
+  set InputArray Calorimeter/towers
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.2
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.2
+
+  set JetPTMin 25.0
+}
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder CaloJetFinder04 {
+  set InputArray Calorimeter/towers
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.4
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.4
+
+  set JetPTMin 25.0
+}
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder CaloJetFinder08 {
+  set InputArray Calorimeter/towers
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.8
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.8
+
+  set JetPTMin 25.0
+}
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder TrackJetFinder02 {
+  set InputArray TrackMerger/tracks
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.2
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.2
+
+  set JetPTMin 25.0
+}
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder TrackJetFinder04 {
+  set InputArray TrackMerger/tracks
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.4
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.4
+
+  set JetPTMin 25.0
+}
+
+
+##################
+# Fast Jet finder
+##################
+
+module FastJetFinder TrackJetFinder08 {
+  set InputArray TrackMerger/tracks
+
+  set OutputArray jets
+
+  # algorithm: 1 CDFJetClu, 2 MidPoint, 3 SIScone, 4 kt, 5 Cambridge/Aachen, 6 antikt
+  set JetAlgorithm 6
+  set ParameterR 0.8
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.8
+
+  set JetPTMin 25.0
 }
 
@@ -662,5 +894,5 @@
 
 module EnergyScale JetEnergyScale {
-  set InputArray FastJetFinder/jets
+  set InputArray FastJetFinder04/jets
   set OutputArray jets
 
@@ -924,5 +1156,4 @@
   add Branch Delphes/allParticles Particle GenParticle
 
-  add Branch GenJetFinder/jets GenJet Jet
   add Branch GenMissingET/momentum GenMissingET MissingET
 
@@ -939,5 +1170,19 @@
   add Branch UniqueObjectFinder/jets Jet Jet
 
-  add Branch FatJetFinder/jets FatJet Jet
+  add Branch GenJetFinder02/jets GenJet02 Jet
+  add Branch GenJetFinder04/jets GenJet04 Jet
+  add Branch GenJetFinder08/jets GenJet08 Jet
+
+  add Branch FastJetFinder02/jets ParticleFlowJet02 Jet
+  add Branch FastJetFinder04/jets ParticleFlowJet04 Jet
+  add Branch FastJetFinder08/jets ParticleFlowJet08 Jet
+
+  add Branch CaloJetFinder02/jets CaloJet02 Jet
+  add Branch CaloJetFinder04/jets CaloJet04 Jet
+  add Branch CaloJetFinder08/jets CaloJet08 Jet
+
+  add Branch TrackJetFinder02/jets TrackJet02 Jet
+  add Branch TrackJetFinder04/jets TrackJet04 Jet
+  add Branch TrackJetFinder08/jets TrackJet08 Jet
 
   add Branch MissingET/momentum MissingET MissingET
